"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _optionalChain(ops) { let lastAccessLHS = undefined; let value = ops[0]; let i = 1; while (i < ops.length) { const op = ops[i]; const fn = ops[i + 1]; i += 2; if ((op === 'optionalAccess' || op === 'optionalCall') && value == null) { return undefined; } if (op === 'access' || op === 'optionalAccess') { lastAccessLHS = value; value = fn(value); } else if (op === 'call' || op === 'optionalCall') { value = fn((...args) => value.call(lastAccessLHS, ...args)); lastAccessLHS = undefined; } } return value; }// src/index.ts
var _unplugin = require('unplugin');
var _pluginutils = require('@rollup/pluginutils');

// src/core/options.ts
function resolveOption(options) {
  return {
    include: options.include || [/\.(vue|[cm]?[jt]sx?)$/],
    exclude: options.exclude || [/node_modules/],
    enforce: "enforce" in options ? options.enforce : "pre"
  };
}

// src/core/transform/index.ts






var _common = require('@vue-macros/common');

// src/core/transform/v-if.ts

function vIfTransform({
  s,
  parseResult
}) {
  const nodeMap = /* @__PURE__ */ new Map();
  _common.walkAST.call(void 0, parseResult, {
    enter(node, parent) {
      if (node.type !== "JSXElement")
        return;
      const attribute = node.openingElement.attributes.find(
        (i) => i.type === "JSXAttribute" && ["v-if", "v-else-if", "v-else"].includes(`${i.name.name}`)
      );
      if (attribute) {
        if (!nodeMap.has(parent))
          nodeMap.set(parent, []);
        _optionalChain([nodeMap, 'access', _ => _.get, 'call', _2 => _2(parent), 'optionalAccess', _3 => _3.push, 'call', _4 => _4({
          node,
          attribute
        })]);
      }
    }
  });
  const nodes = [...nodeMap.values()].flat();
  nodes.forEach(({ node, attribute }, index) => {
    if (["v-if", "v-else-if"].includes(`${attribute.name.name}`)) {
      if (attribute.value)
        s.appendLeft(
          node.start,
          `${attribute.name.name === "v-if" ? "{ " : ""}${s.slice(
            attribute.value.start + 1,
            attribute.value.end - 1
          )} ? `
        );
      s.appendRight(
        node.end,
        `${_optionalChain([nodes, 'access', _5 => _5[index + 1], 'optionalAccess', _6 => _6.attribute, 'access', _7 => _7.name, 'access', _8 => _8.name])}`.startsWith("v-else") ? " :" : " : ''}"
      );
      s.removeNode(attribute);
    } else {
      s.appendRight(node.end, " }");
    }
  });
  return s;
}

// src/core/transform/v-for.ts

function vForTransform({
  s,
  parseResult
}) {
  const nodes = [];
  _common.walkAST.call(void 0, parseResult, {
    enter(node) {
      if (node.type !== "JSXElement")
        return;
      const attribute = node.openingElement.attributes.find(
        (i) => i.type === "JSXAttribute" && ["v-for"].includes(`${i.name.name}`)
      );
      if (attribute) {
        nodes.push({
          node,
          attribute
        });
      }
    }
  });
  nodes.forEach(({ node, attribute }) => {
    if (`${attribute.name.name}` === "v-for") {
      if (!attribute.value)
        return;
      const [i, , list] = s.slice(attribute.value.start + 1, attribute.value.end - 1).split(/\s/);
      s.appendLeft(node.start, ` { ${list}.map(${i}=>`);
      s.appendRight(node.end, ") }");
      s.removeNode(attribute);
    }
  });
  return s;
}

// src/core/transform/index.ts
function transform(code, id) {
  const lang = _common.getLang.call(void 0, id);
  let content = code;
  if (lang === "vue") {
    const { scriptSetup, script } = _common.parseSFC.call(void 0, code, id);
    content = `${_optionalChain([scriptSetup, 'optionalAccess', _9 => _9.content])}${_optionalChain([script, 'optionalAccess', _10 => _10.content])}`;
  }
  if (!/v-for|v-if/.test(content))
    return null;
  const parseResult = _common.babelParse.call(void 0, code, lang === "vue" ? "js" : lang);
  const s = new (0, _common.MagicString)(code);
  if (content.includes("v-if"))
    vIfTransform({ s, parseResult });
  if (content.includes("v-for"))
    vForTransform({ s, parseResult });
  return _common.getTransformResult.call(void 0, s, id);
}

// src/index.ts
var src_default = _unplugin.createUnplugin.call(void 0, (rawOptions = {}) => {
  const options = resolveOption(rawOptions);
  const filter = _pluginutils.createFilter.call(void 0, options.include, options.exclude);
  const name = "unplugin-jsx-vue-directive";
  return {
    name,
    enforce: options.enforce,
    transformInclude(id) {
      return filter(id);
    },
    transform
  };
});



exports.src_default = src_default;
